<?php

class PluginNediinventoryConfig extends CommonDBTM
{
	
    // Load configuration form
    function getConfiguration() {
        global $DB;
        
    	// get all information of this device from nedi:
    	$prop_query = sprintf("SELECT param, value FROM glpi_plugin_nediinventory_nediinventory");
    	$prop_results = $DB->query($prop_query);
    	
    	//Read configuration values
    	$arr_nediConfig = array();
    	if ($prop_results && $DB->numrows($prop_results) > 0) {
    		
    		// Add all Devices from NeDi matching the Device Name
    		while($prop_row = $DB->fetch_assoc($prop_results)) {
    			
    			if ($prop_row['param'] == "default_entityID"){    				
    				
    				$prop_row['value'] = self::getParamConfigDropdown($prop_row['param'], $prop_row['value'], "glpi_entities");

    			} elseif ($prop_row['param'] == "default_stateID"){
    				
    				$prop_row['value'] = self::getParamConfigDropdown($prop_row['param'], $prop_row['value'], "glpi_states");
    				
    			} elseif ($prop_row['param'] == "nedi_Links_Version"){
    				
    				// get all information of this device from nedi:
    				$prop_query = sprintf("SELECT value FROM glpi_plugin_nediinventory_nediinventory WHERE param = 'nedi_Links_Version';");
    				$prop_results = $DB->query($prop_query);
    				$defaultNediVersion = "1_0_8";
    				$arrSupportedNediVersions = array("1_0_8", "1_0_9");
    				
    				//Read configuration values
    				while($prop_entityRow = $DB->fetch_assoc($prop_results)) {
    					
    					$defaultNediVersion = $prop_entityRow['value'];
    					
    				}
    				$prop_row['value'] = "<select name='nedi_Links_Version'>";
    				
    				foreach ($arrSupportedNediVersions as $nediVersion) {
    					if ($nediVersion == $defaultNediVersion){
    						$prop_row['value'] .= "<option value='".$nediVersion."' selected='selected'>$nediVersion</option>";
    					} else {
    						$prop_row['value'] .= "<option value='".$nediVersion."'>$nediVersion</option>";
    					}
    				}
    				$prop_row['value'] .= "</select>";
    					
    				
    			} else {
    				
    			}
    			$arr_nediConfig[] = $prop_row;    			
    		}
    	}
    	return $arr_nediConfig;
    }

    
    private function getParamConfigDropdown($paramName, $selValue, $glpi_db_table) {
    	global $DB;
    	 
    	// get all information of this device from nedi:
    	$prop_query = sprintf("SELECT id, name FROM ".$glpi_db_table);
    	$prop_results = $DB->query($prop_query);
    
    	//Read configuration values
    	$arr_glpiEntities = array();
    	if ($prop_results && $DB->numrows($prop_results) > 0) {
    		 
    		// Add all Devices from NeDi matching the Device Name
    		$html_entitiesSel = "<select name='".$paramName."'>";
    		while($prop_entityRow = $DB->fetch_assoc($prop_results)) {
    			
    			if ($prop_entityRow['id'] == $selValue){
    
    				$html_entitiesSel .= "<option value='".$prop_entityRow['id']."' selected='selected'>".$prop_entityRow['name']."</option>";
    			} else {
    				$html_entitiesSel .= "<option value='".$prop_entityRow['id']."'>".$prop_entityRow['name']."</option>";
    			}
    		}
    		$html_entitiesSel .= "<select>";
    		return $html_entitiesSel;
    	}
    	return null;
    }
    
    // Update the configuration after Post
    function setConfiguration($_POST) {
    	global $DB;
    	
    	if (isset($_POST['default_entityID'])){
    		
    		//Register Nedi Device <> Glpi NetworkEquipment Relation
    		$ne_link_query = sprintf("UPDATE glpi.glpi_plugin_nediinventory_nediinventory SET value = '%d' WHERE glpi_plugin_nediinventory_nediinventory.param = 'default_entityID';", mysql_real_escape_string($_POST['default_entityID']));
    		$ne_link_results = $DB->query($ne_link_query) or die('ERROR UPDATING  glpi_plugin_nediinventory_nediinventory Parameter: default_entityID');
    	} 
    	
    	if (isset($_POST['default_stateID'])){

    		//Register Nedi Device <> Glpi NetworkEquipment Relation
    		$ne_link_query = sprintf("UPDATE glpi.glpi_plugin_nediinventory_nediinventory SET value = '%d' WHERE glpi_plugin_nediinventory_nediinventory.param = 'default_stateID';", mysql_real_escape_string($_POST['default_stateID']));
    		$ne_link_results = $DB->query($ne_link_query) or die('ERROR UPDATING  glpi_plugin_nediinventory_nediinventory Parameter: default_stateID');
    	}
    	
    	if (isset($_POST['nedi_Links_Version'])){
    	
    		//Register Nedi Device <> Glpi NetworkEquipment Relation
    		$ne_link_query = sprintf("UPDATE glpi.glpi_plugin_nediinventory_nediinventory SET value = '%s' WHERE glpi_plugin_nediinventory_nediinventory.param = 'nedi_Links_Version';", mysql_real_escape_string($_POST['nedi_Links_Version']));
    		$ne_link_results = $DB->query($ne_link_query) or die('ERROR UPDATING  glpi_plugin_nediinventory_nediinventory Parameter: nedi_Links_Version');
    	}
    	
    	
    	echo "Updates done.";
    }

    function showConfigForm() {
        global $LANG;
		global $DB;
	
        echo "<form method='post' action='./config.form.php' method='post'>";
        echo "<table class='tab_cadre' cellpadding='5'>";
        echo "<tr><th colspan='2'>".$LANG['plugin_nediinventory']['config'][1]."</th></tr>";
        
        $arr_nediConfig = self::getConfiguration();
        foreach ($arr_nediConfig as $arr_configParamValue){
        	
        	if ($arr_configParamValue['param'] == "default_entityID"){
        		
        		echo "<tr><td>Default Import Entity:</td>";
        		echo "<td>".$arr_configParamValue['value']."</td></tr>";
        	
        	} elseif ($arr_configParamValue['param'] == "default_stateID"){
        		
        		echo "<tr><td>Default Import Status:</td>";
        		echo "<td>".$arr_configParamValue['value']."</td></tr>";
        		
        	} elseif ($arr_configParamValue['param'] == "nedi_Links_Version"){
        		
        		echo "<tr><td>Installed NeDi Version:</td>";
        		echo "<td>".$arr_configParamValue['value']."</td></tr>";
        	
        	} else {
        		echo "<tr><td>".$arr_configParamValue['param']."</td>";
        		echo "<td>".$arr_configParamValue['value']."</td></tr>";
        	}
        	
        }
		echo "<tr><td>";
		
        echo "</td></tr>";
	echo "<tr><td>";
        echo "<input type='submit' name='update' value='".$LANG['plugin_nediinventory']['config'][2]."' class='submit'/>";

        echo "</td></tr>";
        echo "</table>";
        Html::closeForm();
    }
}
?>
