<?php

class PluginNediinventoryNediinventory extends CommonDBTM
{

	
	public static $debug_enabled = false;
	
	/*
	 * Register the Tabs
	 */
    function getTabNameForItem( CommonGLPI $item, $withtemplate = 0 ) {
    	global $LANG;
    	
        if ($item->getType() == 'NetworkEquipment') {
        	
        	$numOfElements = count(self::getModulesOfNetworkEquipment($item->getField('id')));
        	if ($numOfElements > 0){
        		return self::createTabEntry( _n($LANG['plugin_nediinventory']['neteqtab']['name'], $LANG['plugin_nediinventory']['neteqtab']['namePL'], $numOfElements, 'nediinventory'), $numOfElements);
        	} else {
        		return array('1' => _n($LANG['plugin_nediinventory']['neteqtab']['name'], $LANG['plugin_nediinventory']['neteqtab']['namePL'], 1, 'nediinventory'));
        	}
        	
            
        } elseif ($item->getType() == 'Peripheral'){
        	
        	$numOfElements = count(self::getChassisOfGenDevice($item->getField('id')));
        	if ($numOfElements > 0){
        		return self::createTabEntry( _n($LANG['plugin_nediinventory']['moduletab']['name'], $LANG['plugin_nediinventory']['moduletab']['name'], $numOfElements, 'nediinventory'), $numOfElements);
        	} else {
        		return array('1' => _n($LANG['plugin_nediinventory']['moduletab']['name'], $LANG['plugin_nediinventory']['moduletab']['name'], 1, 'nediinventory'));
        	}
        }
        return '';
    }

    
    // Display the content of a Tab
    static function displayTabContentForItem( CommonGLPI $item, $tabnum=1, $withtemplate=0 ) {
    	
    	$str_NeDiversion = self::getNediinventoryConfigSetting("nedi_Links_Version");
    	
    	
        if ($item->getType() == 'NetworkEquipment') {
        	
        	include_once dirname(__FILE__)."/../front/neteq.form.php";
        	$nedipluginForm = new NetworkEquipmentForm();

            $ID = $item->getField('id');
            $Name = $item->getField('name');

            //$nedipluginForm->showForm( $ID, $Name );
            $arr_Modules = self::getModulesOfNetworkEquipment($ID);
            $nedipluginForm->showNetworkEquipmentTab($arr_Modules, $Name, $str_NeDiversion);
            
            
        } elseif ($item->getType() == 'Peripheral'){
        	
        	include_once dirname(__FILE__)."/../front/genDev.form.php";
        	$genDevForm = new GenericDeviceForm();
        	
        	$ID = $item->getField('id');
        	$Serial = $item->getField('serial');
        	
        	//$genDevForm->showForm( $ID, $Serial );
        	$arr_Chassis = self::getChassisOfGenDevice($ID);
        	$genDevForm->showModuleChassisTab($arr_Chassis, $Serial, $str_NeDiversion);
//         } else {
//         	error_log('Clicked Tab item: '.$item->getType());
        }
        return true;
    }

#    function defineTabs($options=array()) {
#        $ong = array();
#        $this->addStandardTab('NetworkEquipment', $ong, $options);
#        $this->addStandardTab('Computer', $ong, $options);
#        $this->addStandardTab('Device', $ong, $options);
#        return $ong;
#    }

//     function showForm( $id ) {
       
//     }

    
    /**
    * Give localized information about 1 task
    *
    * @param $name of the task
    *
    * @return array of strings
    */
   static function cronInfo($name) {

      switch ($name) {
         case 'SyncNedi' :
            return array('description' => __('Sync Nedi inventory into GLPI', 'nediinventory'),
                         'parameter'   => __('Sync Nedi Cron parameter', 'nediinventory'));
      }
      return array();
   }

   
    public static function cronSyncNedi(CronTask $item) {
        global $DB;

        //$me = new PluginNediinventoryNediinventory();
        // Switch Debug modus on
        self::$debug_enabled = ( self::getNediinventoryConfigSetting("enable_debug") > 0 ? true : false );

        //TODO: This is a limit to synch only 10000 Delements from Nedi.Devices
        $max_jobs = 10000;
        $count_jobs = 0;


        /*
         * Read all NEDI.DEVICES not available in the GLPI Nediinventory Plugin Relation Table
         */
        // First check if there are new devices to import. Not present in nediinventory-2-networkEquipment
        //$query = 'SELECT device FROM nedi.devices WHERE device NOT IN (SELECT nedi_device FROM glpi.glpi_plugin_nediinventory_nedilinksneteq)';
        
        //Import and  also ALL devices from nedi to GLPI
        $query = 'SELECT device FROM nedi.devices;';

        $results = $DB->query($query);
        if (self::$debug_enabled) error_log('Starting NeDi-Glpi Sync... ');
        
        if ($results && $DB->numrows($results) > 0) {
            //error_log('[DEBUG] Sync Start: '.$DB->numrows($results).' new nedi devices found.');
            
            
            /*
             * Now fetch the required Configuration and Environment values from GLPI
             */
            //Entity
            $entity_id = self::getDefaultImportEntity();
            
            //State ID
            $state_id = self::getDefaultImportStatus();
            
            //Loop through all network devices
            while($row = $DB->fetch_assoc($results) and $count_jobs <= $max_jobs) {
            	
                $nedi_device = $row['device'];
                
                // get all information of this device from nedi:
                $prop_query = sprintf("SELECT device, serial, contact, description, type, memcpu, bootimage, icon FROM nedi.devices WHERE device = '%s'", mysql_real_escape_string($nedi_device));
                $prop_results = $DB->query($prop_query);
                
                //Test if the NeworkEquipment (Nedi Device) is found in NeDi
                if ($prop_results && $DB->numrows($prop_results) > 0) {
                	
                	// Add all Devices from NeDi matching the Device Name
                    while($prop_row = $DB->fetch_assoc($prop_results) and $count_jobs <= $max_jobs) {
                    	
                    	/*
                    	 * Device Specific Drop-Downs are defined now
                    	 */
                    	//Manufacturer
                    	$deviceManufacturerColorChar = substr($prop_row['icon'], 2, 1);
                    	$manufacturerID = self::getNetworkEquipmentManufacturerID($deviceManufacturerColorChar);
                    	
                    	
                    	//Device Model ( Type in NeDi )
                    	$deviceModelID = self::getNetworkEquipmentModelID($prop_row['type']);
                    	$deviceFirmwareID = self::getNetworkEquipmentFirmwareID($prop_row['bootimage']);
                    	
                    	$deviceMemoryFree = intval(intval($prop_row['memcpu']) / 1000000);
                    	
                    	//Verify that this Network Equipment is not available jet in the GLPI networks table
                    	$GlpiNetEq_ID = self::getGLPINetworkEquipmentByName($prop_row['device']);
                    	
                    	//Create a new Network Equipment
                    	if ($GlpiNetEq_ID == null){

                    		$GlpiNetEq_ID = self::createNetworkEquipment($entity_id, $prop_row, $state_id, $deviceModelID, $deviceFirmwareID, $deviceMemoryFree, $manufacturerID);
                    		
                    		//Register Nedi Device <> Glpi NetworkEquipment Relation
                    		//Test if Relation to NetworkEquipment Aleady exists
                    		$prop_FindExistingRelation_query = sprintf("SELECT nedi_device FROM glpi.glpi_plugin_nediinventory_nedilinksneteq WHERE nedi_device = '%s'", mysql_real_escape_string($prop_row['device']));
                    		$prop_FindExistingRelation_results = $DB->query($prop_FindExistingRelation_query);
                    		
                    		//If relations already exists update the GLPI NetEq ID
                    		if ($prop_FindExistingRelation_results && $DB->numrows($prop_FindExistingRelation_results) > 0) {
                    			 
                    			$ne_link_query = sprintf("UPDATE `glpi`.`glpi_plugin_nediinventory_nedilinksneteq` SET `glpi_networkequipments_id` = '%d' WHERE CONVERT( `glpi_plugin_nediinventory_nedilinksneteq`.`nedi_device` USING utf8 ) = '%s' AND glpi_plugin_nediinventory_nedilinksneteq.nedi_device_serial = '%s' LIMIT 1;", $GlpiNetEq_ID, $prop_row['device'], $prop_row['serial']);
                    			$ne_link_results = $DB->query($ne_link_query) or die('ERROR UPDATING glpi_plugin_nediinventory_nedilinksneteq. glpi_networkequipments_id: '.$GlpiNetEq_ID.' nedi_device: '.$prop_row['device'].' nedi_device_serial: '.$prop_row['serial']);
                    			//error_log('[DEBUG] UPDATE glpi_plugin_nediinventory_nedilinksneteq SET glpi_networkequipments_id: '.$GlpiNetEq_ID.' WHERE nedi_device: '.$prop_row['device'].' nedi_device_serial: '.$prop_row['serial']);
                    			
                    		//If relations does not exist, rebind with new id
                    		} else {

                    			$ne_link_query = sprintf("INSERT INTO glpi_plugin_nediinventory_nedilinksneteq ( glpi_networkequipments_id, nedi_device, nedi_device_serial ) VALUES (%d, '%s', '%s')", $GlpiNetEq_ID, $prop_row['device'], $prop_row['serial']);
                    			$ne_link_results = $DB->query($ne_link_query) or die('ERROR INSERTING into glpi_plugin_nediinventory_nedilinksneteq. glpi_networkequipments_id: '.$GlpiNetEq_ID.' nedi_device: '.$prop_row['device'].' nedi_device_serial: '.$prop_row['serial']);
                    			//error_log('[DEBUG] INSERT glpi_plugin_nediinventory_nedilinksneteq');
                    		}
                    		
                    	//Rejoin Network Equiptment
                    	} else {

                    		//Update of NetEquipment. We do not update: Manufacturer = shout hopefully stay the same J
                    		if (self::$debug_enabled) error_log('[+] Nedi.Device <> Glpi NetworkEqu rejoin. Nedi Device '.$prop_row['device'].' already exists in GLPI with ID: '.$GlpiNetEq_ID);
                    		self::updateNetworkEquipment($GlpiNetEq_ID, $prop_row, $deviceModelID, $deviceFirmwareID, $deviceMemoryFree);
						}
                        
                        
                        //Register / Update all attached Modules
                        $arr_glpiDeviceModules = self::register_update_GlpiDeviceModule($GlpiNetEq_ID, $prop_row['device'], $prop_row['contact'], $entity_id, $state_id);
                        
                        //Register Nedi Module <> Glpi Peripheral relation
                        if (self::$debug_enabled) error_log('[DEBUG] Ok imported NetworkEquipment: "'.$prop_row['device'].'" Proceeding with its Modules...');
                        self::updateNediModule2NetwEquipment($GlpiNetEq_ID, $prop_row['device'], $prop_row['contact'], $entity_id, $state_id, $arr_glpiDeviceModules);
                        
                        
                        $count_jobs++;
                    }
                    
                } else {
                	error_log('Advice: The expected DeviceName: '.$nedi_device.' could not be found in NeDi! Skip step.');
                }
            }
        } else {
        	
        	error_log('There are no NEW devices from NeDi to be imported');
        }

        // now check if there are new modules to add:
        $modules_query = "SELECT * FROM nedi.modules WHERE serial != '' AND serial NOT IN (SELECT nedi_modules_serial FROM glpi_plugin_nediinventory_nedilinksdev)";
        

        return $count_jobs;
    }
    
    
    
    
   
    
    
    
    /**
     * DEFAULT GENERAL SETTINGS
     * 
     */
    /*
     * Discover the default import entity
     */
    private static function getDefaultImportEntity() {
    	global $DB;
    	
    	$defaultEntityID = self::getNediinventoryConfigSetting("default_entityID");
    	if (!isset($defaultEntityID) || $defaultEntityID == "" ){
    		error_log('Get Entity ID: Fallback to default entity ID "0"');
    		$defaultEntityID = 0;
    	}
    	return $defaultEntityID;
    }
    
    /*
     * Discover the default import status
    */
    private static function getDefaultImportStatus() {
    	global $DB;
    	
    	$defaultStateID = self::getNediinventoryConfigSetting("default_stateID");
    	if (!isset($defaultStateID) || $defaultStateID == "" ){
    		error_log('Get State ID: Fallback to default state ID "0"');
    		$defaultStateID = 0;
    	}
    	return $defaultStateID;
    }
    
    /*
     * Generic function: Load Plugin config variables
    */
    private static function getNediinventoryConfigSetting($param) {
    	global $DB;
    	 
    	$prop_query = sprintf("SELECT value FROM glpi_plugin_nediinventory_nediinventory WHERE param = '%s'", mysql_real_escape_string($param));
    	$prop_results = $DB->query($prop_query);
    
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['value'];
    	}
    	return null;
    }
    
    
    
    /**
     * NETWORK EQUIPMENT HANDLING
     *
     *
     *
     *
     */
    /*
     * Proof if a Network Equipment with the Name as in Nedi.Devices already exists
     * Then get the GLPI NetEq ID to bind !
     */
    private static function getGLPINetworkEquipmentByName($nediDeviceName){
    	global $DB;
    	 
    	$prop_query = sprintf("SELECT id FROM `glpi_networkequipments` where name = '%s'", mysql_real_escape_string($nediDeviceName));
    	$prop_results = $DB->query($prop_query);
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['id'];
    	}
    	return null;
    }
    
    
    /*
     * NetworkEquipment Manufacturer
     */
    private static function getNetworkEquipmentManufacturerID($deviceManufacturerColorChar) {
    	global $DB;
    	
    	$deviceManufacturerString = "";
    	
    	/*
    	 * NeDi Color Codes:
    	 * Vendor 	Color
    	 * Cisco 	blue
    	 * Dell (Force10) 	cyan
    	 * HP 	green
    	 * Avaya (Nortel) 	orange
    	 * Extreme 	purple
    	 * Alcatel-Lucent 	yellow
    	 * Brocade (Foundry) 	red
    	 * Other 	black
    	 */
    	switch ($deviceManufacturerColorChar) {
    		case 'b': $deviceManufacturerString = "Cisco"; break;
    		case 'c': $deviceManufacturerString = "Dell"; break;
    		case 'g': $deviceManufacturerString = "Hewlett-Packard"; break;
    		case 'o': $deviceManufacturerString = "Nortel"; break;
    		case 'p': $deviceManufacturerString = "Extreme"; break;
    		case 'y': $deviceManufacturerString = "Alcatel-Lucent"; break;
    		case 'r': $deviceManufacturerString = "Brocade (Foundry)"; break;
    		case 'a': $deviceManufacturerString = "Other"; break;
    		
    		default: $deviceManufacturerString = "Unknown"; break;
    	}
    	
    	$prop_query = sprintf("SELECT id FROM glpi_manufacturers WHERE name = '%s'", mysql_real_escape_string($deviceManufacturerString));
    	$prop_results = $DB->query($prop_query);
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['id'];
    	}
    	
    	$neManufact_input = array();
    	$neManufact_input["name"] = $deviceManufacturerString;
    	$manufacturer = new Manufacturer();
    	$manufacturerID = $manufacturer->add($neManufact_input);
    	if (self::$debug_enabled) error_log('[DEBUG] Add Manufacturer: '.$deviceManufacturerString.' generated a new entry with ID: '.$manufacturerID);
    	return $manufacturerID;
    	

    }
    /*
     * Discover and Create the Network Equipment Type
    */
    private static function getNetworkEquipmentFirmwareID($deviceFirmware){
    	global $DB;
    	 
    	$prop_query = sprintf("SELECT id FROM glpi_networkequipmentfirmwares WHERE name = '%s'", mysql_real_escape_string($deviceFirmware));
    	$prop_results = $DB->query($prop_query);
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['id'];
    	}
    	 
    	$neMod_input = array();
    	$neMod_input["name"] = $deviceFirmware;
    	$neFirmware = new NetworkEquipmentFirmware();
    	$neFirmwareID = $neFirmware->add($neMod_input);
    	if (self::$debug_enabled) error_log('[DEBUG] Add NetEq Firmware: '.$deviceFirmware.' generated a new entry with ID: '.$neFirmwareID);
    	return $neFirmwareID;
    }
    
    /*
     * Discover and Create the Network Equipment Model
    */
    private static function getNetworkEquipmentModelID($deviceModel){
    	global $DB;
    	
    	$prop_query = sprintf("SELECT id FROM glpi_networkequipmentmodels WHERE name = '%s'", mysql_real_escape_string($deviceModel));
    	$prop_results = $DB->query($prop_query);
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['id'];
    	}
    	
    	$neMod_input = array();
    	$neMod_input["name"] = $deviceModel;
    	$neModel = new NetworkEquipmentModel();
    	$neModelID = $neModel->add($neMod_input);
    	if (self::$debug_enabled) error_log('Add NetEq Model: Model '.$deviceModel.' generated a new entry with ID: '.$neModelID);
    	return $neModelID;
    }
    
    /*
     * Get Modules Registered to a Network Equipment
    */
    private static function getModulesOfNetworkEquipment($neEquipmentID) {
    	global $DB;
    	 
    	//error_log('DEBUG: Searching for eq id: '.$neEquipmentID);
    	 
    	$prop_query = sprintf("SELECT P.id AS ID, P.name AS Name, P.serial AS serial, T.name AS type, M.name AS model, R.installation_status AS installation_status, R.last_discovery AS last_discovery
			FROM glpi.glpi_plugin_nediinventory_nedilinksdev R
			JOIN glpi.glpi_peripherals P ON P.id = R.glpi_peripherals_id
			JOIN glpi_peripheraltypes T ON T.id = P.peripheraltypes_id
			JOIN glpi_peripheralmodels M ON M.id = P.peripheralmodels_id
			WHERE glpi_networkEquipment_id = '%d' AND P.is_deleted = 0 AND P.is_template = 0;", mysql_real_escape_string($neEquipmentID));
    	 
    	$prop_results = $DB->query($prop_query);
    	 
    	$arr_Modules = array();
    	if ($prop_results && $DB->numrows($prop_results) > 0) {
    
    		// Get all Device Modules
    		while($prop_row = $DB->fetch_assoc($prop_results)) {
    
    			$arr_module = array();
    			$arr_module['id'] = $prop_row['ID'];
    			$arr_module['name'] = $prop_row['Name'];
    			$arr_module['serial'] = $prop_row['serial'];
    			$arr_module['type'] = $prop_row['type'];
    			$arr_module['model'] = $prop_row['model'];
    			$arr_module['installation_status'] = $prop_row['installation_status'];
    			$arr_module['last_discovery'] = $prop_row['last_discovery'];
    			$arr_Modules[] = $arr_module;
    		}
    	}
    	return $arr_Modules;
    }
    
    /*
     * Create NetWork Equipment
    *
    */
    private static function createNetworkEquipment($entity_id, $prop_row, $state_id, $deviceModelID, $deviceFirmwareID, $deviceMemoryFree, $manufacturerID) {
    	global $DB;
    	
    	# NEDI COLS: device,devip,serial,type,firstdis,lastdis,services,description,devos,bootimage,location,contact,devgroup,devmode,snmpversion,readcomm,cliport,login,icon,origip,cpu,memcpu,temp,cusvalue,cuslabel,sysobjid,writecomm,devopts,size,stack,maxpoe,totpoe,cfgchange,cfgstatus
    	# GLPI COLS: entities_id:0 is_recursive:1 name:test states_id:0 locations_id:7 networkequipmenttypes_id:0 users_id_tech:12 manufacturers_id:0  groups_id_tech:2 networkequipmentmodels_id:0 contact_num: serial: contact: otherserial: users_id:0 networks_id:0 groups_id:0 comment:sdfsdf domains_id:0 networkequipmentfirmwares_id:0 ram:64G
    	$ne_input = array();
    	$ne_input['entities_id'] = $entity_id;
    	$ne_input['is_recursive'] = 1;
    	$ne_input['name'] = $prop_row['device'];
    	$ne_input['states_id'] = $state_id;
    	$ne_input['locations_id'] = 0;
    	$ne_input['networkequipmenttypes_id'] = 0;
    	$ne_input['users_id_tech'] = 0;
    	$ne_input['manufacturers_id'] = 0;
    	$ne_input['groups_id_tech'] = 0;
    	$ne_input['networkequipmentmodels_id'] = $deviceModelID;
    	$ne_input['networkequipmentfirmwares_id'] = $deviceFirmwareID;
    	$ne_input['manufacturers_id'] = $manufacturerID;
    	$ne_input['contact_num'] = '';
    	$ne_input['serial'] = $prop_row['serial'];
    	$ne_input['contact'] = $prop_row['contact'];
    	$ne_input['otherserial'] = '';
    	$ne_input['users_id'] = 0;
    	$ne_input['networks_id'] = 0;
    	$ne_input['groups_id'] = 0;
    	$ne_input['comment'] = $prop_row['description'];
    	$ne_input['domains_id'] = 0;
    	$ne_input['networkequipmentfirmwares_id'] = 0;
    	$ne_input['ram'] = $deviceMemoryFree;
    	$ne = new NetworkEquipment();
    	$GlpiNetEq_ID = $ne->add($ne_input);
    	
    	return $GlpiNetEq_ID;
    }
    
    /*
     * Update NetWork Equipment
     * 
     * Make sure to not overwrite locked fields ( make use of fusionplugin lock logic )
     * Uupdate only provided values ;)
     */
    private static function updateNetworkEquipment($GlpiNetEq_ID, $arr_networkEquipment, $deviceModelID, $deviceFirmwareID, $deviceMemoryFree) {
    	global $DB;
    	
    	$strOutput="";
    	
    	//Get fusioninventory Lock Row for network equipment
    	$prop_query = sprintf("SELECT tablefields FROM `glpi_plugin_fusioninventory_locks` 
    			WHERE tablename = 'glpi_networkequipments' AND items_id = '%d'", mysql_real_escape_string($GlpiNetEq_ID));
    	$prop_results = $DB->query($prop_query);
    	
    	//Test is modules are attached and then loop through them
    	$netEqu_lockString = "";
    	
    	if ($prop_results && $DB->numrows($prop_results) > 0){
    	
    		// Add all Devices from NeDi matching the Device Name
    		$prop_row = $DB->fetch_assoc($prop_results);
    		$netEqu_lockString = $prop_row['tablefields'];
    	}
    	
    	$ne_input = array();
    	$ne_input['id'] = $GlpiNetEq_ID;
    	
    	//NeDi Device Name is a key in NeDi:
    	$ne_input['name'] = $arr_networkEquipment['device'];

    	//Model
    	if (!strstr($netEqu_lockString, "networkequipmentmodels_id")){
    		$ne_input['networkequipmentmodels_id'] = $deviceModelID;
    	}
    	//Firmware
    	if (!strstr($netEqu_lockString, "networkequipmentfirmwares_id")){
    		$ne_input['networkequipmentfirmwares_id'] = $deviceFirmwareID;
    	}
    	//Serial
    	if (!strstr($netEqu_lockString, "serial")){
    		$ne_input['serial'] = $arr_networkEquipment['serial'];
    	} else {
    		$strOutput .= "Serial ";
    	}
    	//Contact
    	if (!strstr($netEqu_lockString, "contact")){
    		$ne_input['contact'] = $arr_networkEquipment['contact'];
		} else {
			$strOutput .= "Contact ";
    	}
    	//Description
    	if (!strstr($netEqu_lockString, "description")){
    		$ne_input['comment'] = $arr_networkEquipment['description'];
		} else {
			$strOutput .= "Description ";
    	}
    	//Ram
    	if (!strstr($netEqu_lockString, "ram")){
    		$ne_input['ram'] = $deviceMemoryFree;
    	} else {
    		$strOutput .= "Ram ";
    	}
    	
    	if (self::$debug_enabled && strlen($strOutput) > 5) error_log("[LockInfo] NetEq: ".$ne_input['name']." Locks: ".$strOutput);
    	$ne = new NetworkEquipment();
    	$ne->update($ne_input);
    	
    	//Workaround but urgently necessary:
    	// When doing update() all updated fields are marked as *locked*,
    	// with this we restore the situation from "before".
    	//Get fusioninventory Lock Row for network equipment
    	$prop_query = sprintf('UPDATE glpi.glpi_plugin_fusioninventory_locks SET tablefields = \'%s\' WHERE tablename = \'glpi_networkequipments\' AND items_id = \'%d\' LIMIT 1;', mysql_real_escape_string($netEqu_lockString), mysql_real_escape_string($GlpiNetEq_ID));
    	$prop_results = $DB->query($prop_query);
    	if (!$prop_results){
    		error_log('[!] updateNetworkEquipment: Error resetting the Lock of Modified fields. NetEqId: '.$GlpiNetEq_ID.' Lock string: '.$netEqu_lockString);
    	}
    	
    }
    
    
    
    
    /**
     * DEVICES ( NETWORK MODULES ) HANDLING
     * 
     * 
     * 
     * 
     */
    
    /*
     * Get the Chassis a Module belongs to
    */
    private static function getChassisOfGenDevice($genDeviceID) {
    	global $DB;
    
    	//error_log('DEBUG: Searching for eq id: '.$neEquipmentID);
    
    	$prop_query = sprintf("SELECT N.id AS ID, N.name AS name, N.serial AS serial, M.name AS model, R.installation_status AS installation_status, R.last_discovery AS last_discovery
			FROM `glpi_plugin_nediinventory_nedilinksdev` R
			JOIN glpi_networkequipments N ON N.id = R.glpi_networkEquipment_id
			JOIN glpi_networkequipmentmodels M ON M.id = N.networkequipmentmodels_id
			WHERE R.glpi_peripherals_id = '%d' AND N.is_deleted = 0 AND N.is_template = 0;", mysql_real_escape_string($genDeviceID));
    
    	$prop_results = $DB->query($prop_query);
    
    	$arr_chassises = array();
    	if ($prop_results && $DB->numrows($prop_results) > 0) {
    
    		// Get all Device Modules
    		while($prop_row = $DB->fetch_assoc($prop_results)) {
    
    			$arr_chassis = array();
    			$arr_chassis['id'] = $prop_row['ID'];
    			$arr_chassis['name'] = $prop_row['name'];
    			$arr_chassis['serial'] = $prop_row['serial'];
    			$arr_chassis['model'] = $prop_row['model'];
    			$arr_chassis['installation_status'] = $prop_row['installation_status'];
    			$arr_chassis['last_discovery'] = $prop_row['last_discovery'];
    			$arr_chassises[] = $arr_chassis;
    		}
    	}
    	return $arr_chassises;
    }
    
    
    /*
     * Nedi ModClassID -> Description -> Glpi TypeID
     */
    private static function nediModClass2ModelTypeID($modclass) {
    	
    	/*
    	 * Defined in: html/inc/libdev.php
    	* function ModClass($cl){
    	*/
    	switch ($modclass) {
    		case 1: $neDev_Type = "Other"; break;
    		case 2: $neDev_Type = "Unknown"; break;
    		case 3: $neDev_Type = "Chassis"; break;
    		case 4: $neDev_Type = "Backplane"; break;
    		case 5: $neDev_Type = "Container"; break;
    		case 6: $neDev_Type = "Power Supply"; break;
    		case 7: $neDev_Type = "Fan"; break;
    		case 8: $neDev_Type = "Sensor"; break;
    		case 9: $neDev_Type = "Module"; break;
    		case 10: $neDev_Type = "Port"; break;
    		case 11: $neDev_Type = "Stack"; break;
    		case 12: $neDev_Type = "CPU"; break;
    		case 30: $neDev_Type = "Printsupply"; break;
    		case 40: $neDev_Type = "Virtual Machine"; break;
    		case 50: $neDev_Type = "Controlled AP"; break;
    		case 60: $neDev_Type = "Server"; break;
    		default: $neDev_Type = "?"; break;
    	}
    	return self::getDeviceTypeID($neDev_Type);
    }
    
    
    
    /*
     * Update Peripheral Device
    *
    * Make sure to not overwrite locked fields ( make use of fusionplugin lock logic )
    * Uupdate only provided values ;)
    */
    private static function updatePeripheralEquipment($GlpiPeripheral_ID, $GlpiPeripheral_Firmware) {
    	global $DB;
    	 
    	$strOutput="";
    	 
    	//Get fusioninventory Lock Row for network equipment
    	$prop_query = sprintf("SELECT tablefields FROM `glpi_plugin_fusioninventory_locks`
    			WHERE tablename = 'glpi_peripherals' AND items_id = '%d'", mysql_real_escape_string($GlpiPeripheral_ID));
    	$prop_results = $DB->query($prop_query);
    	 
    	//Test is modules are attached and then loop through them
    	$peripheral_lockString = "";
    	 
    	if ($prop_results && $DB->numrows($prop_results) > 0){
    		 
    		// Add all Devices from NeDi matching the Device Name
    		$prop_row = $DB->fetch_assoc($prop_results);
    		$peripheral_lockString = $prop_row['tablefields'];
    	}
    	 
    	$perif_input = array();
    	$perif_input['id'] = $GlpiPeripheral_ID;
    	 
    	//Firmware
    	if (!strstr($peripheral_lockString, "brand")){
    		$perif_input['brand'] = $GlpiPeripheral_Firmware;
    	}
    
    	 
    	if (self::$debug_enabled && strlen($strOutput) > 5) error_log("[LockInfo] Peripheral: ".$perif_input['name']." Locks: ".$strOutput);
    	$nePeripheral = new Peripheral();
    	$nePeripheral->update($perif_input);
    	 
    	//Workaround but urgently necessary:
    	// When doing update() all updated fields are marked as *locked*,
    	// with this we restore the situation from "before".
    	//Get fusioninventory Lock Row for network equipment
    	$prop_query = sprintf('UPDATE glpi.glpi_plugin_fusioninventory_locks SET tablefields = \'%s\' WHERE tablename = \'glpi_peripherals\' AND items_id = \'%d\' LIMIT 1;', mysql_real_escape_string($peripheral_lockString), mysql_real_escape_string($GlpiPeripheral_ID));
    	$prop_results = $DB->query($prop_query);
    	if (!$prop_results){
    		error_log('[!] updatePeripheralEquipment: Error resetting the Lock of Modified fields. NetEqId: '.$GlpiPeripheral_ID.' Lock string: '.$peripheral_lockString);
    	}
    	 
    }
    
    
    /*
     * Register Modules to Network Equiptment
    */
    private static function register_update_GlpiDeviceModule($glpiNeEqID, $nediDevicename, $neDevContact, $entity_id, $state_id) {
    	global $DB;
    	 
    	// get all information of this device from nedi:
    	/*
    	* NEDI COLS => GLPI Cols
    	* serial	=> serial		FOC152800RN
    	* model 	=> model			WS-C3750E-48TD-S
    	* moddesc	=> comment		C2911 Mother board 3GE, integrated VPN and 4W
    	* slot		=> name			C2911 Mother board 3GE, integrated VPN and 4W on Slot 0
    	* modclass	=> Type			Module, Chassis, Port, ...
    	* fw		=> Firmware		Firmware of Module
    	* 
    	* GLPI.Peripherals Attributes: id,entities_id,name,date_mod,contact,contact_num,users_id_tech,groups_id_tech,comment,serial,otherserial,locations_id,peripheraltypes_id,peripheralmodels_id,brand,manufacturers_id,is_global,is_deleted,is_template,template_name,notepad,users_id,groups_id,states_id,ticket_tco,is_dynamic
    	*/
    	$arr_glpiDeviceModules = array();
    	
    	$prop_query = sprintf("SELECT device, serial, model, moddesc, slot, modclass, fw FROM nedi.modules WHERE device = '%s'", mysql_real_escape_string($nediDevicename));
    	$prop_results = $DB->query($prop_query);
    	 
    	//Test is modules are attached and then loop through them
    	if ($prop_results && $DB->numrows($prop_results) > 0) {
    	 
    		// Add all Modules from NeDi matching the Device Name
    		while($prop_row = $DB->fetch_assoc($prop_results)) {
    			
    			//Check if Module is already available in GLPI
    			$neDev = new Peripheral();
    			$arr_devices = $neDev->find("serial = '".$prop_row['serial']."' AND name = '".$prop_row['slot']."'", "name");
    			
    			//If the Module already exists in GLPI
    			if (count($arr_devices) > 0){
    				
	    			foreach ($arr_devices as $arr_glpiPeripheral) {
	    				
	    				if (self::$debug_enabled) error_log('[DEBUG] The Glpi.Module already exists with ID: '.$arr_glpiPeripheral['id'].' Name(Slot): '.$arr_glpiPeripheral['name'].' Serial: '.$arr_glpiPeripheral['serial']);
	    				//Update the Module
	    				
	    				//Update fields that can change: 
	    				// - Firmware
	    				if ($arr_glpiPeripheral['brand'] != $prop_row['fw']){
	    					
	    					self::updatePeripheralEquipment($arr_glpiPeripheral['id'], $prop_row['fw']);
	    				}
	    				//Return the whole array for update of the relation
	    				$arr_glpiDeviceModules[] = $arr_glpiPeripheral;
	    				break;
	    			}
    				
    			// Module has to be created
    			} else {
    				
    				if (self::$debug_enabled) error_log('[DEBUG] No Module existing for: serial = '.$prop_row['serial'].' AND name = '.$prop_row['slot'].' -> Create!');
    				
    				//Just verify that Model or Description field is available and take the available values
    				$neDev_Model = (strlen($prop_row['model']) > 3) ? $prop_row['model'] : $prop_row['moddesc'];
    				$neDev_Descr = (strlen($prop_row['moddesc']) > 3) ? $prop_row['moddesc'] : $prop_row['model'];
    				
    				//Device Model
    				$neDevModelID = self::getDeviceModelID($neDev_Model);
    				 
    				//Device Type: This list ist taken from NEDI as translated from Id in source code
    				$neDevTypeID = self::nediModClass2ModelTypeID($prop_row['modclass']);
    				 
    				
    				//GLPI Device (Peripheral) == Nedi Module
    				$neDev_input = array();
    				$neDev_input['entities_id'] = $entity_id;
    				$neDev_input['states_id'] = $state_id;
    				$neDev_input['name'] = $prop_row['slot'];
    				$neDev_input['serial'] = $prop_row['serial'];
    				$neDev_input['comment'] = $neDev_Descr;
    				$neDev_input['contact'] = $neDevContact;
    				$neDev_input['brand'] = $prop_row['fw'];
    				
    				$neDev_input['peripheralmodels_id'] = $neDevModelID;
    				$neDev_input['peripheraltypes_id'] = $neDevTypeID;
    					
    				$neDev = new Peripheral();
    				$neDev_id = $neDev->add($neDev_input);
    				
    				//Return including the new ID
    				$neDev_input['id'] = $neDev_id;
    				
    				//Pass this new Device with its values to the array to create the relation!
    				$arr_glpiDeviceModules[] = $neDev_input;
    			}	
    		}
		}
		return $arr_glpiDeviceModules;
	}
	
	
	/**
	 * Update NeDi Modules <-> Glpi Network Equiptment Relation
	 * 
	 * Synchronisation Relation Keys:
	 * Nedi Device name <-> GLPI NetwEquipment <-> GLPI Device
	 * 
	 * 1) Assume SERIAL number must not be UNIQUE.
	 * 2) Module mit not unique serial number moves to another Device
	 * -> Old relation becomes "uninstalled"
	 * -> New realation to existing GLPI-Device-ID is generated 
	 * 
	*/
	private static function updateNediModule2NetwEquipment($glpiNeEqID, $nediDevicename, $neDevContact, $entity_id, $state_id, $arr_glpiDeviceModules) {
		global $DB;
	
// 		//Read all Nedi Modules of Nedi Device
// 		$nediModules_query = sprintf("SELECT device, slot, serial, model, moddesc, modclass FROM nedi.modules WHERE device = '%s'", mysql_real_escape_string($nediDevicename));
// 		$nediModules_results = $DB->query($nediModules_query);
		
		//1) Reset all active installation of Glpi NetEquipment
		//Do not disable everythin by default !
		$reset_query = sprintf("UPDATE glpi.glpi_plugin_nediinventory_nedilinksdev SET installation_status = 'uninstalled'
					WHERE glpi_networkEquipment_id = '%d'", mysql_real_escape_string($glpiNeEqID));
		$reset_results = $DB->query($reset_query);
		if (!$reset_results){
			error_log('[!] updateNediModule2NetwEquipment: Error in NetEq-Device-Link Reset of NetEqId: '.$glpiNeEqID.' Abort.');
			return false;
		}
		
 		
		//Loop through all GLPI Modules of this netEquipment
		foreach ($arr_glpiDeviceModules as $glpiModule_row) {
			
			//Check if Module is already in relation on this DEVICE to GLPI.Peripherals. 
			//Keys: Module.Device AND Module.Slot AND GLPI.NetEquipmentId AND GLPI.PeripheralID
			
			//FIX: Update also PeripheralID: when installing a Module on a new Switch, the Relation MUST INCLUDE the new network device
			$Nedi2GlpiNetEq_query = sprintf("SELECT glpi_peripherals_id, glpi_networkEquipment_id, nedi_modules_serial, nedi_module_device, nedi_module_slot, installation_status
					FROM glpi_plugin_nediinventory_nedilinksdev
					WHERE nedi_module_device = '%s' AND nedi_module_slot = '%s' AND glpi_networkEquipment_id = '%d' AND glpi_peripherals_id = '%d';",
					mysql_real_escape_string($nediDevicename), mysql_real_escape_string($glpiModule_row['name']), mysql_real_escape_string($glpiNeEqID), mysql_real_escape_string($glpiModule_row['id']));
			$Nedi2GlpiNetEq_results = $DB->query($Nedi2GlpiNetEq_query);
			
			// If want to keep history, match also Glpi.peripheral relation
			//WHERE nedi_module_device = '%s' AND nedi_module_slot = '%s' AND glpi_networkEquipment_id = '%d' AND AND glpi_peripherals_id = '%d';",
			//mysql_real_escape_string($nediDevicename), mysql_real_escape_string($glpiModule_row['name']), mysql_real_escape_string($glpiNeEqID), mysql_real_escape_string($glpiModule_row['id']));
			
			// IF RELATION EXISTS: YES => Update, IF NO => Register relation
			if ($Nedi2GlpiNetEq_results && $DB->numrows($Nedi2GlpiNetEq_results) > 0) {

				if (self::$debug_enabled) error_log('[DEBUG] Reactivate nediModule Device: '.$nediDevicename.' Slot: '.$glpiModule_row['name'].'  <> Glpi.Peripheral '.$glpiModule_row['name']);
				
				
				$Nedi2GlpiNetEq_setInstalled_query = sprintf("UPDATE glpi.glpi_plugin_nediinventory_nedilinksdev
					SET installation_status = 'installed', last_discovery = NOW()
					WHERE nedi_module_device = '%s' AND nedi_module_slot = '%s' AND glpi_networkEquipment_id = '%d';",
					mysql_real_escape_string($nediDevicename), mysql_real_escape_string($glpiModule_row['name']), mysql_real_escape_string($glpiNeEqID));
				
			
				$Nedi2GlpiNetEq_setInstalled_results = $DB->query($Nedi2GlpiNetEq_setInstalled_query);
				if (!$Nedi2GlpiNetEq_setInstalled_results){
					error_log('[!] updateNediModule2NetwEquipment: Error in Updating the Nedi Module Relation: Device: '.$nediDevicename.' Module Slot: '.$glpiModule_row['name']);
				}
					
			} else {
					
				if (self::$debug_enabled) error_log('[DEBUG] Create new relation nediModule <> Glpi.Peripheral');
				
				$Nedi2GlpiNetEq_setInstalled_query = sprintf("INSERT INTO glpi.glpi_plugin_nediinventory_nedilinksdev (
					glpi_peripherals_id, glpi_networkEquipment_id, nedi_modules_serial, nedi_module_device, nedi_module_slot, installation_status, last_discovery ) VALUES (
					'%d', '%d', '%s', '%s', '%s', 'installed', NOW());",
					mysql_real_escape_string($glpiModule_row['id']), mysql_real_escape_string($glpiNeEqID), mysql_real_escape_string($glpiModule_row['serial']), mysql_real_escape_string($nediDevicename), mysql_real_escape_string($glpiModule_row['name']));
					
				$Nedi2GlpiNetEq_setInstalled_results = $DB->query($Nedi2GlpiNetEq_setInstalled_query);
				if (!$Nedi2GlpiNetEq_setInstalled_results){
					error_log('[!] updateNediModule2NetwEquipment: Error on Nedi Module Relation Insert: GLPInetEQID: '.$glpiNeEqID.' GLPIModID: '.$glpiModule_row['id'].' NediModSerial: '.$glpiModule_row['serial'].' NediDeviceName: '.$nediDevicename.' Module Slot: '.$glpiModule_row['name']);
				}
			}	
		}		
	}
    
	
	
    /*
     * Discover and Create the Device Type ID
    */
    private static function getDeviceTypeID($neDev_TypeStr){
    	global $DB;
    	 
    	$prop_query = sprintf("SELECT id FROM glpi_peripheraltypes WHERE name = '%s'", mysql_real_escape_string($neDev_TypeStr));
    	$prop_results = $DB->query($prop_query);
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['id'];
    	}
    	 
    	$neDev_input = array();
    	$neDev_input["name"] = $neDev_TypeStr;
    	$neDev_TypeObj = new PeripheralType();
    	$neDevTypeID = $neDev_TypeObj->add($neDev_input);
    	if (self::$debug_enabled) error_log('Add Device Type: "'.$neDev_TypeStr.'" generated a new entry with ID: '.$neDevTypeID);
    	return $neDevTypeID;
    }
    
    /*
     * Discover and Create the Device Model ID
    */
    private static function getDeviceModelID($neDev_ModelStr){
    	global $DB;
    
    	$prop_query = sprintf("SELECT id FROM glpi_peripheralmodels WHERE name = '%s'", mysql_real_escape_string($neDev_ModelStr));
    	$prop_results = $DB->query($prop_query);
    	while($prop_row = $DB->fetch_assoc($prop_results)) {
    		 
    		return $prop_row['id'];
    	}
    
    	$neDev_input = array();
    	$neDev_input["name"] = $neDev_ModelStr;
    	$neDev_ModelObj = new PeripheralModel();
    	$neDevModelID = $neDev_ModelObj->add($neDev_input);
    	if (self::$debug_enabled) error_log('Add Device Model: "'.$neDev_ModelStr.'" generated a new entry with ID: '.$neDevModelID);
    	return $neDevModelID;
    }
}


?>
